/***********************************************************************************/
/**	\file				ScreenModes.h
**	\brief				Header File zur Klasse ScreenModes
*************************************************************************************
**	Autor:				Christian Roesch
*************************************************************************************
**	_tut nichts_
**
*//*********************************************************************************/

#ifndef _ScreenModes_H
#define _ScreenModes_H

// includes
#include <vector>

#include "Singleton.h"
#include "Config.h"
#include "DataSet.h"

// Klassen-Deklaration

namespace FrameWork
{

/***********************************************************************************/
/** \brief	ScreenModes _tut nichts_
*************************************************************************************
**	Genau genommen _tut dies nichts_
**
*//*********************************************************************************/

class	ScreenModes : public FrameWork::Singleton<ScreenModes>
{
public:
	ScreenModes();
	~ScreenModes();

	bool read( std::string strFile="screen/modes.txt" );

	struct Mode
	{
		std::string m_strName;

		int m_iWidth;
		int m_iHeight;
		bool m_bFullScreen;

		float m_fVirtualX;
		float m_fVirtualY;

		Config m_cfgVirtualData;

		float getScaledFloatX( std::string strKey );
		float getScaledFloatY( std::string strKey );
	};

	Mode*	getActMode();
	int		getActModeIndex();
	void	setActMode( int iIndex ); 
	
	int		getModeCount();
	Mode*	getMode( int iIndex );

protected:

private:
	int m_iActMode;
	std::vector< Mode* > m_vecModes;

	Mode m_modeDummy;
};

}

#endif//_ScreenModes_H

class	FrameWork::ScreenModes;


/************************************************************************************
**	Ende der Datei:		ScreenModes.h
************************************************************************************/ 
