/*	                     __      __
	                     \ \    / /
	                      \ \  / /
	         _      _______\ \/ /_______      _
	        / \    / __________________ \    / \
	       (   \  | /        __        \ |  /   )
	     ___\  |  | |       / _\       | |  |  /___
	    |____  |  | |      ( <_        | |  | _____|
	      / \| |  | |       \__/       | |  | |/ \
	     / \ | |  | \__________________/ |  | | / \
	    /_/ \__/   \____________________/   \__/ \_\
	 ___  _   _ ___ __  __   _   _  _ ___   _     ____ __
	|   \| | | / __|  \/  | /_\ | \| |_ _| /_\   |__  /  \
	| |) | |_| \__ \ |\/| |/ _ \| .` || | / _ \    / / () |
	|___/ \___/|___/_|  |_/_/ \_\_|\_|___/_/ \_\  /_(_)__/

	      Framework fr den Spieleprogrammierwettbewerb
	             by David Scherfgen (TomasRiker)
*/

#include <cassert>
#include "animationset.h"
#include "animation.h"
using namespace std;

namespace FrameWork
{
	AnimationSet::AnimationSet()
	{
	}

	AnimationSet::~AnimationSet()
	{
	}

	Animation* AnimationSet::createAnimation(const string& name,
											 float speed)
	{
		// prfen, ob es nicht schon eine Animation mit diesem Namen gibt
		assert(!findAnimation(name));

		// neue Animation erzeugen und in die Liste eintragen
		Animation* p_anim = new Animation(name, speed);
		animations.push_back(p_anim);
		return p_anim;
	}

	void AnimationSet::deleteAnimation(const string& name)
	{
		// Instanz lschen
		Animation* p_anim = findAnimation(name);
		delete p_anim;

		// aus der Liste entfernen
		for(list<Animation*>::iterator i = animations.begin(); i != animations.end(); i++)
		{
			if((*i)->getName() == name)
			{
				animations.erase(i);
				break;
			}
		}
	}

	Animation* AnimationSet::findAnimation(const string& name)
	{
		for(list<Animation*>::iterator i = animations.begin(); i != animations.end(); i++)
		{
			if((*i)->getName() == name) return *i;
		}

		// Nicht gefunden!
		return 0;
	}
}
