/*	                     __      __
	                     \ \    / /
	                      \ \  / /
	         _      _______\ \/ /_______      _
	        / \    / __________________ \    / \
	       (   \  | /        __        \ |  /   )
	     ___\  |  | |       / _\       | |  |  /___
	    |____  |  | |      ( <_        | |  | _____|
	      / \| |  | |       \__/       | |  | |/ \
	     / \ | |  | \__________________/ |  | | / \
	    /_/ \__/   \____________________/   \__/ \_\
	 ___  _   _ ___ __  __   _   _  _ ___   _     ____ __
	|   \| | | / __|  \/  | /_\ | \| |_ _| /_\   |__  /  \
	| |) | |_| \__ \ |\/| |/ _ \| .` || | / _ \    / / () |
	|___/ \___/|___/_|  |_/_/ \_\_|\_|___/_/ \_\  /_(_)__/

	      Framework fr den Spieleprogrammierwettbewerb
	             by David Scherfgen (TomasRiker)
*/

#ifndef _ANIMATIONSET_H
#define _ANIMATIONSET_H

#include <d3dx9.h>
#include <string>
#include <list>

namespace FrameWork
{
	class Animation;

	// Klasse fr eine Sammlung von Animationen
	class AnimationSet
	{
	public:
		AnimationSet();
		~AnimationSet();

		// legt eine neue Animation an
		Animation* createAnimation(const std::string& name, float speed);

		// lscht eine Animation
		void deleteAnimation(const std::string& name);

		// sucht eine Animation anhand ihres Namens
		Animation* findAnimation(const std::string& name);

	private:
		std::list<Animation*> animations;
	};
}

#endif
