/*	                     __      __
	                     \ \    / /
	                      \ \  / /
	         _      _______\ \/ /_______      _
	        / \    / __________________ \    / \
	       (   \  | /        __        \ |  /   )
	     ___\  |  | |       / _\       | |  |  /___
	    |____  |  | |      ( <_        | |  | _____|
	      / \| |  | |       \__/       | |  | |/ \
	     / \ | |  | \__________________/ |  | | / \
	    /_/ \__/   \____________________/   \__/ \_\
	 ___  _   _ ___ __  __   _   _  _ ___   _     ____ __
	|   \| | | / __|  \/  | /_\ | \| |_ _| /_\   |__  /  \
	| |) | |_| \__ \ |\/| |/ _ \| .` || | / _ \    / / () |
	|___/ \___/|___/_|  |_/_/ \_\_|\_|___/_/ \_\  /_(_)__/

	      Framework fr den Spieleprogrammierwettbewerb
	             by David Scherfgen (TomasRiker)
*/

#include "d3dresource.h"
using namespace std;

namespace FrameWork
{
	list<D3DResource*> D3DResource::resources;

	D3DResource::D3DResource()
	{
		resources.push_back(this);
	}

	D3DResource::~D3DResource()
	{
		resources.remove(this);
	}

	void D3DResource::handleLostDevice()
	{
		for(list<D3DResource*>::iterator i = resources.begin(); i != resources.end(); i++) (*i)->onLostDevice();
	}

	void D3DResource::handleResetDevice()
	{
		for(list<D3DResource*>::iterator i = resources.begin(); i != resources.end(); i++) (*i)->onResetDevice();
	}

	void D3DResource::onLostDevice()
	{
	}

	void D3DResource::onResetDevice()
	{
	}
}
