/*	                     __      __
	                     \ \    / /
	                      \ \  / /
	         _      _______\ \/ /_______      _
	        / \    / __________________ \    / \
	       (   \  | /        __        \ |  /   )
	     ___\  |  | |       / _\       | |  |  /___
	    |____  |  | |      ( <_        | |  | _____|
	      / \| |  | |       \__/       | |  | |/ \
	     / \ | |  | \__________________/ |  | | / \
	    /_/ \__/   \____________________/   \__/ \_\
	 ___  _   _ ___ __  __   _   _  _ ___   _     ____ __
	|   \| | | / __|  \/  | /_\ | \| |_ _| /_\   |__  /  \
	| |) | |_| \__ \ |\/| |/ _ \| .` || | / _ \    / / () |
	|___/ \___/|___/_|  |_/_/ \_\_|\_|___/_/ \_\  /_(_)__/

	      Framework fr den Spieleprogrammierwettbewerb
	             by David Scherfgen (TomasRiker)
*/

#include "dsoundresource.h"
using namespace std;

namespace FrameWork
{
	list<DSoundResource*> DSoundResource::resources;

	DSoundResource::DSoundResource()
	{
		resources.push_back(this);
	}

	DSoundResource::~DSoundResource()
	{
		resources.remove(this);
	}

	void DSoundResource::freeze()
	{
		for(list<DSoundResource*>::iterator i = resources.begin(); i != resources.end(); i++) (*i)->onFreeze();
	}

	void DSoundResource::unfreeze()
	{
		for(list<DSoundResource*>::iterator i = resources.begin(); i != resources.end(); i++) (*i)->onUnfreeze();
	}

	void DSoundResource::onFreeze()
	{
	}

	void DSoundResource::onUnfreeze()
	{
	}
}
