/*	                     __      __
	                     \ \    / /
	                      \ \  / /
	         _      _______\ \/ /_______      _
	        / \    / __________________ \    / \
	       (   \  | /        __        \ |  /   )
	     ___\  |  | |       / _\       | |  |  /___
	    |____  |  | |      ( <_        | |  | _____|
	      / \| |  | |       \__/       | |  | |/ \
	     / \ | |  | \__________________/ |  | | / \
	    /_/ \__/   \____________________/   \__/ \_\
	 ___  _   _ ___ __  __   _   _  _ ___   _     ____ __
	|   \| | | / __|  \/  | /_\ | \| |_ _| /_\   |__  /  \
	| |) | |_| \__ \ |\/| |/ _ \| .` || | / _ \    / / () |
	|___/ \___/|___/_|  |_/_/ \_\_|\_|___/_/ \_\  /_(_)__/

	      Framework fr den Spieleprogrammierwettbewerb
	             by David Scherfgen (TomasRiker)
*/

#ifndef _FONT_H
#define _FONT_H

#include <d3dx9.h>
#include <string>
#include "d3dresource.h"

namespace FrameWork
{
	class Surface;

	// Flags fr Schriftart
	enum FontFlags
	{
		FF_BOLD = 1,		// fett
		FF_ULTRABOLD = 2,	// ultrafett (krass)
		FF_ITALIC = 4		// kursiv
	};

	// Flags zum Rendern von Text
	enum DrawTextFlags
	{
		DTF_HCENTER = 1,	// horizontal zentrieren
		DTF_VCENTER = 2,	// vertikal zentrieren
		DTF_RIGHT = 4,		// rechts ausrichten
		DTF_BOTTOM = 8,		// unten ausrichten
		DTF_USECAMERA = 16	// Kameraposition bercksichtigen
	};

	// Klasse zum Rendern von Text
	class Font : public D3DResource
	{
	public:
		Font(const std::string& fontName, int width, int height, DWORD flags = 0);
		~Font();

		void onLostDevice();
		void onResetDevice();

		// zeichnet einen Text auf eine Oberflche
		void drawText(Surface* p_dest, const D3DXVECTOR2& position, const std::string& text, DWORD flags = 0, DWORD color = D3DCOLOR_XRGB(255, 255, 255));

		ID3DXFont* getFont() {return p_font;}

	private:
		ID3DXFont* p_font;
		D3DXFONT_DESC fontDesc;
	};
}

#endif
