/*	                     __      __
	                     \ \    / /
	                      \ \  / /
	         _      _______\ \/ /_______      _
	        / \    / __________________ \    / \
	       (   \  | /        __        \ |  /   )
	     ___\  |  | |       / _\       | |  |  /___
	    |____  |  | |      ( <_        | |  | _____|
	      / \| |  | |       \__/       | |  | |/ \
	     / \ | |  | \__________________/ |  | | / \
	    /_/ \__/   \____________________/   \__/ \_\
	 ___  _   _ ___ __  __   _   _  _ ___   _     ____ __
	|   \| | | / __|  \/  | /_\ | \| |_ _| /_\   |__  /  \
	| |) | |_| \__ \ |\/| |/ _ \| .` || | / _ \    / / () |
	|___/ \___/|___/_|  |_/_/ \_\_|\_|___/_/ \_\  /_(_)__/

	      Framework fr den Spieleprogrammierwettbewerb
	             by David Scherfgen (TomasRiker)
*/
// modified 12.11.05 (TGGC)

#ifndef _FRAMEWORK_H
#define _FRAMEWORK_H

#include "singleton.h"
#include "graphics.h"
#include "d3dresource.h"
#include "surface.h"
#include "font.h"
#include "particlesystem.h"
#include "particleemitter.h"
#include "animation.h"
#include "animationset.h"
#include "animated.h"
#include "dsoundresource.h"
#include "audio.h"
#include "sound.h"
#include "soundinstance.h"
#include "input.h"
#include "game.h"
#include "gamestate.h"
#include "timer.h"
#include "utils.h"
#include "ivec2.h"
#include "safe.h"

namespace FrameWork
{
	typedef D3DXVECTOR2 vec2;
	typedef D3DXVECTOR3 vec3;
	typedef D3DXCOLOR color;
}

#endif
