/*	                     __      __
	                     \ \    / /
	                      \ \  / /
	         _      _______\ \/ /_______      _
	        / \    / __________________ \    / \
	       (   \  | /        __        \ |  /   )
	     ___\  |  | |       / _\       | |  |  /___
	    |____  |  | |      ( <_        | |  | _____|
	      / \| |  | |       \__/       | |  | |/ \
	     / \ | |  | \__________________/ |  | | / \
	    /_/ \__/   \____________________/   \__/ \_\
	 ___  _   _ ___ __  __   _   _  _ ___   _     ____ __
	|   \| | | / __|  \/  | /_\ | \| |_ _| /_\   |__  /  \
	| |) | |_| \__ \ |\/| |/ _ \| .` || | / _ \    / / () |
	|___/ \___/|___/_|  |_/_/ \_\_|\_|___/_/ \_\  /_(_)__/

	      Framework fr den Spieleprogrammierwettbewerb
	             by David Scherfgen (TomasRiker)
*/

#ifndef _ivec2_H
#define _ivec2_H

#include <d3dx9.h>

namespace FrameWork
{
	// 2D-Integer
	class ivec2
	{
	public:
		ivec2() {}
		ivec2(const ivec2& v) : x(v.x), y(v.y) {}
		ivec2(int c_x, int c_y) : x(c_x), y(c_y) {}
		ivec2(const D3DXVECTOR2& v) : x(static_cast<int>(v.x)), y(static_cast<int>(v.y)) {}
		~ivec2() {}

		ivec2 operator + (const ivec2& v) const {return ivec2(x + v.x, y + v.y);}
		ivec2 operator - (const ivec2& v) const {return ivec2(x - v.x, y - v.y);}
		ivec2 operator - () const {return ivec2(-x, -y);}
		const ivec2& operator = (const ivec2& v) {x = v.x; y = v.y; return *this;}
		const ivec2& operator += (const ivec2& v) {return *this = *this + v;}
		const ivec2& operator -= (const ivec2& v) {return *this = *this - v;}
		bool operator == (const ivec2& v) const {return x == v.x && y == v.y;}
		bool operator != (const ivec2& v) const {return !(*this == v);}

		operator D3DXVECTOR2 () const {return D3DXVECTOR2(static_cast<float>(x), static_cast<float>(y));}

		int x, y;
	};
}

#endif
