/*	                     __      __
	                     \ \    / /
	                      \ \  / /
	         _      _______\ \/ /_______      _
	        / \    / __________________ \    / \
	       (   \  | /        __        \ |  /   )
	     ___\  |  | |       / _\       | |  |  /___
	    |____  |  | |      ( <_        | |  | _____|
	      / \| |  | |       \__/       | |  | |/ \
	     / \ | |  | \__________________/ |  | | / \
	    /_/ \__/   \____________________/   \__/ \_\
	 ___  _   _ ___ __  __   _   _  _ ___   _     ____ __
	|   \| | | / __|  \/  | /_\ | \| |_ _| /_\   |__  /  \
	| |) | |_| \__ \ |\/| |/ _ \| .` || | / _ \    / / () |
	|___/ \___/|___/_|  |_/_/ \_\_|\_|___/_/ \_\  /_(_)__/

	      Framework fr den Spieleprogrammierwettbewerb
	             by David Scherfgen (TomasRiker)
*/

#ifndef _SOUND_H
#define _SOUND_H

#include <dsound.h>
#include <string>
#include <list>

namespace FrameWork
{
	class SoundInstance;

	// Klasse fr einen Sound
	class Sound
	{
	public:
		Sound(const std::string& filename);
		Sound(HMODULE module, LPCTSTR p_resource);
		~Sound();

		// liefert eine neue Instanz dieses Sounds
		SoundInstance* createInstance(bool persist = false);

		// lscht eine Instanz dieses Sounds
		void deleteInstance(SoundInstance* p_inst);

		// prft, ob die angegebene Instanz gltig ist
		bool isValidInstance(const SoundInstance* p_inst);

	private:
		void gc();

		static std::list<Sound*> sounds;

		IDirectSound8* p_dSound;
		IDirectSoundBuffer* p_buffer;
		std::list<SoundInstance*> instances;
	};
}

#endif
